      integer lu, istart, irun, istop, nl, np, n, iz
      integer nmin, nmax, emin, emax, nnl, nnp, i
      real    pixdimn, pixdime, north, east, scale
      PARAMETER (LU=1)
      PARAMETER (ISTART=0,IRUN=1,ISTOP=9999)
      PARAMETER (NL=1747,NP=2423)
      integer IZ(NP), izz(np)
      character ret*1
      REAL ZCL(40), xs, ys, xo, yo
C
      OPEN (UNIT=LU,FILE='topo.unf',STATUS='OLD',form='unformatted')
      pixdimn = 63.987
      pixdime = 63.964
C   
      CALL GROUTE(' ')   
      CALL GOPEN
      call gsegcr(1)
C   
C  Place image in plot area     
C   
      nmin = 0
      nmax = 10000000
      emin = 0
      emax = 10000000
      nnp = np
      nnl = nl
      open(unit=2,file='limit',status='old',err=99)
      read(2,*) nmin, nmax
      read(2,*) emin, emax
      read(2,*) scale
      nnp = nint( float(emax-emin)/pixdime )
      nnl = nint( float(nmax-nmin)/pixdimn )
c
99    XO=40.           
      YO=5.
      XS = (emax-emin) * scale / 1000.0
      YS=XS*FLOAT(nnl)/FLOAT(nnp)
      CALL GVPORT(XO,YO,XS,YS)
C
      CALL GHALF
C
C  Set "undefined" value and no color
C                       
      CALL RUNDEF(0.0,9999)
C
C  Set option for horizontal scan
C
      CALL GIMSCN(1)
C                                             
C  Set propagation
C                 Left-to-right
C                 |  Top-to-bottom
C                 |  |
      CALL GIMDIR(1,-1)
C
C  Program a       From        To         Number of colors
C  color scale:    H  L  S     H  L  S    |  Color index
C                  |  |  |     |  |  |    |  |
      CALL GLDHLS(340,80,100, 260,30,100, 2,50)
      CALL GLDHLS(260,30,100, 260,50,100, 4,51)
      CALL GLDHLS(260,50,100, 160,50,100,10,54)
      CALL GLDHLS(160,50,100, 160,10,100, 8,63)
      CALL RSHADE(50,-21)
      call rin('Lower limit ?',zcl(1))
      call rin('Upper limit ?',zcl(2))
      CALL RCLASS(ZCL,40,3)
C
C  Initialize Image Rendering
C                        
      CALL GIMAGI(IZ,NP,ISTART)
C
C  Read and process image line by line
C                              
      north = 5205444.50 
      DO N=1,NL
        READ(LU) IZ
        if(north.ge.nmin.and.north.le.nmax) then
          nnp = 0
          east = 577564.188
          do i = 1, np 
            if(east.ge.emin.and.east.le.emax) then
              nnp = nnp + 1
              izz(nnp) = iz(i)
            end if
            east = east - pixdime
          end do
          CALL GIMAGI(izz,nnp,IRUN)
        end if
        north = north - pixdimn
      end do
C                              
C  Terminate Image Rendering and close input file
C
      CALL GIMAGI(IZ,NP,ISTOP)
      CLOSE(UNIT=LU)
C
C  Plot a color scale 20 mm to the left of the image
C
      CALL GCOSCS(XO-20.,YO)
C
C  Plot title. Position in plot area units    
C
      CALL GSCAMM     
      CALL RTXFON('SWIM',0)
      CALL RTXHEI(YS*.06)
      CALL RTXJUS(1,2)
      CALL RTX(-2,'Relief map of Sudbury',XS*.5+20.,YS*1.3) 
      CALL RTXHEI(YS*.04)
      CALL RTX(-2,'(altitude in meters)',XS*.5+20.,YS*1.2)  
C    
      call tin('Press return to stop ',ret)
      CALL GCLOSE  
      call gsegcl(1) 
      STOP  
      END   
