      real      ch(20), ht, dc, hz(20), errs(10), hzerr(20), time(20)
      real      x(500), y(500), z(500), xl(20), yl(20), zl(20)
      integer   nchan, i, ista, ie(20), j, iloc(500), dim, ncorners
      integer   ic, imin,imax
      character lfile*80, dfile*80, ofile*80, ufile*80, aa*75
      data      errs/50.0,0.15,0.3,0.7,1.5,2.8,7.0,13.0,20.0,50.0/
      data      dfile/'l1001l1.c3'/, ufile/'rxutm.xyz'/
      data      lfile/'alp1.txt'/, imin/0/, imax/10000/
      data      time/15.1460,10.7100, 7.5731, 5.3550, 3.7870, 
     >                2.6780, 1.8930, 1.3390, 0.9466, 0.6694, 
     >                0.4733, 0.3347, 0.2366, 0.1673, 0.1183, 
     >                0.0837, 0.0592, 0.0418, 0.0296, 0.0209/
c
      nchan = 20
      call iin('Minimum station label ?',imin)
      call iin('Maximum station label ?',imax)
      call tin('Name of utm line file ?',ufile)
      open(unit=1,file=ufile,status='old')
      i = 1
      do while(.true.)
        read(1,*,end=100) j, iloc(i), x(i), y(i), z(i) 
        i = i + 1
      end do
100   close(unit=1)
      dim = i
c
      call tin('Name of loop file ?',lfile)
      open(unit=1,file=lfile,status='old')
      do i = 1, 15
        read(1,'(a)') aa 
      end do
      call atoi(aa(index(aa,':')+2:),ncorners)
      read(1,'(a)') aa 
      do i = 1, ncorners
        read(1,*) j, xl(i), yl(i), zl(i)
      end do
      close(unit=1)
c
      call tin('Name of data file ?',dfile)
      open(unit=1,file=dfile,status='old')
      ofile = dfile(1:index(dfile,'.'))//'out'
c
      call tin('Name of output file ?',ofile)
      call trunc(ofile,i)
      open(unit=2,file=ofile,status='unknown')
      open(unit=3,file=ofile(1:i)//'.xvgr',status='unknown')
c
c add utm correction to loop coordinates
c
      write(2,*) ncorners
      do i = 1, ncorners
        write(2,*) xl(i), yl(i), zl(i)
      end do
      write(2,*) xl(1), yl(1), zl(1)
      write(2,*) nchan

      do while(.true.) 
        read(1,*,end=200) ista
        read(1,*) (ch(i),i=1,nchan)
        read(1,*) ht, dc
        read(1,*) (ie(i),i=1,nchan)
c
        call find(ista,iloc,dim,ic)
        if(ista.ge.imin.and.ista.le.imax) then
          write(2,*) ista, x(ic), y(ic), z(ic)
          write(3,*) ' '
c
          do i = 1, nchan
            hz(i) = ch(i) * ht / 100.0 
            hzerr(i) = abs( hz(i) * errs(ie(i)+1) / 100.0 )
          end do
c
          do i = 1, nchan
            write(2,1) time(i)*1.0e-03, hz(i), hzerr(i)
c
c Write out the step-off response
c
            hz(i) = (hz(i) - ht*dc)
            write(3,1) time(i)*1.0e-03, abs(hz(i)), hzerr(i)
          end do
          write(2,*) ht*dc
        end if
      end do
1     format(5x,3(1pe14.7,2x))
200   stop
      end
c---------------------------------------------------------------------
      subroutine find(i,array,dim,ic)
c---------------------------------------------------------------------
      integer ic, dim, array(dim), i
c
      do ic = 1, dim
        if(i.eq.array(ic)) return
      end do
      return
      end
