      real      ch(20), ht, dc, hz(20), errs(10), hzerr(20), time(20)
      real      x(500), y(500), z(500), xl(10), yl(10), zl(10)
      real      chs(20), hts
      integer   nchan, i, ista, ie(20), j, iloc(500), dim, ncorners
      integer   ic, ies(20)
      character lfile*80, dfile*80, ofile*80, ufile*80, aa*75, sfile*80
      data      errs/50.0,0.15,0.3,0.7,1.5,2.8,7.0,13.0,20.0,50.0/
      data      dfile/'process/l1001l1.c3'/, ufile/'stripped/rxutm.xyz'/
      data      lfile/'process/alp1.txt'/, sfile/'stripped/l1fl1.c3'/
      data      time/15.1460,10.7100, 7.5731, 5.3550, 3.7870, 
     >                2.6780, 1.8930, 1.3390, 0.9466, 0.6694, 
     >                0.4733, 0.3347, 0.2366, 0.1673, 0.1183, 
     >                0.0837, 0.0592, 0.0418, 0.0296, 0.0209/
c
      nchan = 20
c
      call tin('Name of utm line file ?',ufile)
      open(unit=1,file=ufile,status='old')
      i = 1
      do while(.true.)
        read(1,*,end=100) j, iloc(i), x(i), y(i), z(i) 
        i = i + 1
      end do
100   close(unit=1)
      dim = i
c
      call tin('Name of loop file ?',lfile)
      open(unit=1,file=lfile,status='old')
      do i = 1, 15
        read(1,'(a)') aa 
      end do
      call atoi(aa(index(aa,':')+2:),ncorners)
      read(1,'(a)') aa 
      do i = 1, ncorners
        read(1,*) j, xl(i), yl(i), zl(i)
      end do
      close(unit=1)
c
      call tin('Name of processed data file ?',dfile)
      open(unit=1,file=dfile,status='old')
      call tin('Name of stripped data file ?',sfile)
      open(unit=3,file=sfile,status='old')
      ofile = dfile(1:index(dfile,'.'))//'out'
c
      call tin('Name of output file ?',ofile)
      open(unit=2,file=ofile,status='unknown')
c
c add utm correction to loop coordinates
c
      write(2,*)   ncorners
      do i = 1, ncorners
        write(2,*) xl(i)+5148820.04, yl(i)+479219.98, zl(i)
      end do
      write(2,*)   xl(1)+5148820.04, yl(1)+479219.98, zl(1)
      write(2,*)   nchan

      do while(.true.) 
        read(1,*,end=200) ista
        read(1,*) (ch(i),i=1,nchan)
        read(1,*) ht, dc
        read(1,*) (ie(i),i=1,nchan)
c
        read(3,*,end=200) ista
        read(3,*) (chs(i),i=1,nchan)
        read(3,*) hts, dc
        read(3,*) (ies(i),i=1,nchan)
c
        call find(ista,iloc,dim,ic)
        write(2,*) ista, x(ic), y(ic), z(ic)
c
        do i = 1, nchan
          hz(i) = (ch(i) * ht - chs(i) * hts ) / 100.0 
          hzerr(i) = abs( hz(i) * errs(ie(i)+1) / 100.0 )
          write(2,1) time(i)*1.0e-03, hz(i), hzerr(i)
        end do
      end do
1     format(5x,3(1pe14.7,2x))
200   stop
      end
c---------------------------------------------------------------------
      subroutine find(i,array,dim,ic)
c---------------------------------------------------------------------
      integer ic, dim, array(dim), i
c
      do ic = 1, dim
        if(i.eq.array(ic)) return
      end do
      return
      end
